com.beaglebuddy.id3.v24.frame_body

## Class ID3v24FrameBodyUserDefinedTextInformation

- java.lang.Object
- - com.beaglebuddy.util.Utility
  - - com.beaglebuddy.id3.v24.frame_body.ID3v24FrameBodyUtility
    - - com.beaglebuddy.id3.v24.frame_body.ID3v24FrameBody
      - - com.beaglebuddy.id3.v24.frame_body.ID3v24FrameBodyUserDefinedTextInformation

-     public class ID3v24FrameBodyUserDefinedTextInformation
      extends ID3v24FrameBody

  A user defined text information frame body is associated with an ID3v2.4 `TXXX` `frame` which is used to include one-string text information concerning the audio file in a similar way to the other `text information` frames. The user defined text information frame body contains the following fields:

  User Defined Text Information Frame Body Fields
  | Field | Description
  --- | --- | ---
  1. | `encoding` | character set used to `encode` the description and text fields.
  2. | description | description of the text field.
  3. | text | the actual text.

  There may be more than one user defined text information frame in an ID3v2.4 `tag`, but only one with the same description field.

  See Also:
    `ID3v24Frame`, ID3 tag version 2.4.0 standard, wikipedia history of ID3 tags

- - ### Field Summary

    - ### Fields inherited from class com.beaglebuddy.id3.v24.frame_body.ID3v24FrameBody

      `buffer, dirty, frameType`

    - ### Fields inherited from class com.beaglebuddy.id3.v24.frame_body.ID3v24FrameBodyUtility

      `nextNullTerminatorIndex, nullTerminatorIndex`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `ID3v24FrameBodyUserDefinedTextInformation()` The default constructor is called when creating a new frame.
    `ID3v24FrameBodyUserDefinedTextInformation(Encoding encoding, java.lang.String description, java.lang.String text)` This constructor is called when creating a new frame.
    `ID3v24FrameBodyUserDefinedTextInformation(java.io.InputStream inputStream, int frameBodySize)` This constructor is called when reading in an existing frame from an .mp3 file.

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `java.lang.String` | `getDescription()` gets the description of the text.
    `Encoding` | `getEncoding()` gets the character encoding of the description and the text..
    `java.lang.String` | `getText()` gets the text.
    `void` | `parse()` parses the raw bytes of the frame body and stores the parsed values in the frame's fields.
    `void` | `setBuffer()` If the frame body's values have been modified, then resize the raw binary buffer and store the new values there.
    `void` | `setDescription(java.lang.String description)` sets the description of the text.
    `void` | `setEncoding(Encoding encoding)` sets the character encoding of the description and the text..
    `void` | `setText(java.lang.String text)` sets the text.
    `java.lang.String` | `toString()` gets a string representation of the user defined text information frame body showing all of the frame's fields and their values.

    - ### Methods inherited from class com.beaglebuddy.id3.v24.frame_body.ID3v24FrameBody

      `getFrameType, getNextNullTerminator, getSize, isDirty, save, save`

    - ### Methods inherited from class com.beaglebuddy.id3.v24.frame_body.ID3v24FrameBodyUtility

      `getNextNullTerminator, pricesToString, stringToBytes`

    - ### Methods inherited from class com.beaglebuddy.util.Utility

      `bytesToInt, bytesToInt, bytesToShort, bytesToShort, bytesToSynchsafeInt, bytesToSynchsafeShort, formateDate, getUTF16String, getUTF8String, hex, hex, hex, intToBytes, littleEndianBytesToInt, pad, shortToBytes, synchsafeIntToBytes`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- - ### Constructor Detail

    - #### ID3v24FrameBodyUserDefinedTextInformation

          public ID3v24FrameBodyUserDefinedTextInformation()

      The default constructor is called when creating a new frame. The default values used are:
      - ISO-8859-1 encoding
      - empty description
      - empty text

    - #### ID3v24FrameBodyUserDefinedTextInformation

          public ID3v24FrameBodyUserDefinedTextInformation(Encoding encoding,
                                                   java.lang.String description,
                                                   java.lang.String text)

      This constructor is called when creating a new frame.
      Parameters:
        `encoding` - character set used to encode the description.
        `description` - description of the text.
        `text` - text;

    - #### ID3v24FrameBodyUserDefinedTextInformation

          public ID3v24FrameBodyUserDefinedTextInformation(java.io.InputStream inputStream,
                                                   int frameBodySize)
                                                    throws java.io.IOException

      This constructor is called when reading in an existing frame from an .mp3 file. This is then followed by a call to the parse() method.
      Parameters:
        `inputStream` - input stream pointing to a user defined text information frame body in the .mp3 file.
        `frameBodySize` - size (in bytes) of the frame body.
      Throws:
        `java.io.IOException` - if there is an error while reading the frame body.

  - ### Method Detail

    - #### parse

          public void parse()
                     throws java.lang.IllegalArgumentException

      parses the raw bytes of the frame body and stores the parsed values in the frame's fields.
      Overrides:
        `parse` in class `ID3v24FrameBody`
      Throws:
        `java.lang.IllegalArgumentException` - if an invalid value is detected while parsing the frame body's raw bytes.

    - #### getEncoding

          public Encoding getEncoding()

      gets the character encoding of the description and the text..
      Returns:
        the character encoding of the description and the text..
      See Also:
        `setEncoding(Encoding)`

    - #### setEncoding

          public void setEncoding(Encoding encoding)

      sets the character encoding of the description and the text..
      Parameters:
        `encoding` - the character set used to encode the description and the text. Only those supported by the `Encoding` enum are allowed.
      See Also:
        `getEncoding()`

    - #### getDescription

          public java.lang.String getDescription()

      gets the description of the text.
      Returns:
        the description of the text.
      See Also:
        `setDescription(String)`

    - #### setDescription

          public void setDescription(java.lang.String description)

      sets the description of the text.
      Parameters:
        `description` - the description of the text.
      See Also:
        `getDescription()`

    - #### getText

          public java.lang.String getText()

      gets the text.
      Returns:
        the text.
      See Also:
        `setText(String)`

    - #### setText

          public void setText(java.lang.String text)

      sets the text.
      Parameters:
        `text` - the text.
      See Also:
        `getText()`

    - #### setBuffer

          public void setBuffer()

      If the frame body's values have been modified, then resize the raw binary buffer and store the new values there. When finished, the dirty flag is reset to indicate that the buffer is up to date, and the frame is now ready to be saved to the .mp3 file.
      Overrides:
        `setBuffer` in class `ID3v24FrameBody`

    - #### toString

          public java.lang.String toString()

      gets a string representation of the user defined text information frame body showing all of the frame's fields and their values.
      Overrides:
        `toString` in class `java.lang.Object`
      Returns:
        a string representation of the frame's body.